# This source file executes code. It sets the working directory and 
# gives values to some global variables:

# computer           which computer this code is running on
# config.dir         directory path for the configuration file config.txt
# java.classpath     java class path for running BEAST
# seqgenbasecmd      file path for calling Seq-Gen

# The configuration file config.txt contains the true MUL-tree and parameters for 
# running BEAST, and so on.

stopifnot(length(Args) == 2)
computer <- Args[1]
stopifnot(Args[1] == "VOSTROWIN7" || Args[1] == "DELLVISTA" || 
          Args[1] == "NETBOOKWIN7" || Args[1] == "NETBOOKUBUNTU" ||
          Args[1] == "CLUSTER")
config.dir <- Args[2]
# input config is here. All output goes in subdirectories of this


## where this code is. todo: other machines
#if (computer=="VOSTROWIN7") {
#  setwd("C:/Users/Graham/AAA/Programming/Goteborg/AlloppRcode-nhybs")
#  } else if  (computer=="DELLVISTA") {
#  setwd("C:/AAA/Programming/Goteborg/AlloppRcode")
#  } else if  (computer=="NETBOOKWIN7") {
#  setwd("C:/AAA/Programming/Goteborg/simulation_di_tets_multigene")
#  } else if  (computer=="NETBOOKUBUNTU") {
#  setwd("/home/graham/simulation_di_tets_multigene")
#  } else if  (computer=="CLUSTER") {
#  setwd("/home/gjones/simulation_di_tets_multigene")
#  }




# java classpath for calling BEAST. todo: other machines
if (computer=="VOSTROWIN7") {
  java.classpath <- "."
  java.classpath <- paste(java.classpath, "C:\\Users\\Work\\AAA\\Programming\\biology\\B20140330\\out\\production\\B20140330" ,sep=";")
  java.classpath <- paste(java.classpath, "C:\\Users\\Work\\AAA\\Programming\\biology\\B20140330\\lib\\*" ,sep=";")
  } else if  (computer=="DELLVISTA") {
  java.classpath <- ".;C:\\AAA\\Programming\\Goteborg\\workspace\\beast16\\bin;C:\\AAA\\Programming\\Goteborg\\workspace\\beast16\\lib\\*"
  } else if  (computer=="NETBOOKWIN7") {
  java.classpath <- ".;C:\\AAA\\Programming\\Goteborg\\workspace\\beast16\\bin;C:\\AAA\\Programming\\Goteborg\\workspace\\beast16\\lib\\*"
  } else if  (computer=="NETBOOKUBUNTU") {
  java.classpath <- "'.:/home/graham/Programming/workspace/beast16/bin/:/home/graham/Programming/workspace/beast16/lib/*'" 
  } else if  (computer=="CLUSTER") {
  java.classpath <- "'.:/home/gjones/beast16/build/:/home/gjones/beast16/lib/*'"
  }   

               
# for calling Seq-Gen             
if (computer=="VOSTROWIN7") {
  seqgenbasecmd <- "seqgen.exe -mHKY -t3.0 -f0.3,0.2,0.2,0.3"
  } else if  (computer=="DELLVISTA") {
  seqgenbasecmd <- "seqgen.exe -mHKY -t3.0 -f0.3,0.2,0.2,0.3"
  } else if  (computer=="NETBOOKWIN7") {
  seqgenbasecmd <- "seqgen.exe -mHKY -t3.0 -f0.3,0.2,0.2,0.3"
  } else if  (computer=="NETBOOKUBUNTU") {
  seqgenbasecmd <- "$PWD/seqgen -mHKY -t3.0 -f0.3,0.2,0.2,0.3" 
  } else if  (computer=="CLUSTER") {
  seqgenbasecmd <- "$PWD/seqgen -mHKY -t3.0 -f0.3,0.2,0.2,0.3"
  }
 