# version 2 is for a set of G,N,T values.
# (G = nof genes, N=nof indivs, T = mutation rate)
#  read.config2() replaces read.config()
#  read.node() is different
# fpath.* functions added


##################################################################################

all.files.prefix.from.config.dir <- function(config.dir) {
scenario.name <- substr(config.dir, nchar(config.dir), nchar(config.dir))
stopifnot(nchar(scenario.name) == 1)
scenario.name
}
              
              
               
# file name components - 'type'
fnc.multree <- "1MT"
fnc.simgtree <- "2GT"
fnc.simseq <- "2SQ"
fnc.beastxml <- "3BX"
fnc.sampledgtrees <- "4GTS"
fnc.sampledmultrees <- "4MTS"
fnc.sampledparams <- "4LOG"
fnc.concensusgtree <- "5GTC"
fnc.concensusmultree <- "5MTC"
fnc.DBUGTUNE <- "9DBUGTUNE"
# file name components which appear before config params
fnc.nofgenes <- "g"
fnc.nofindivs <- "n"
fnc.mutrate <- "t"
fnc.replicate <- "r"



fpath.GNTname <- function(config, i) {
  G <- config$configG[i]
  N <- config$configN[i]
  mu <- config$configT[i]
  R <- config$configR[i]
  GNTname <- paste(fnc.nofgenes , G, 
                   fnc.nofindivs, N,                                                                                                                  
                   fnc.mutrate, as.integer(round(mu*1e9)), sep="")
  GNTname                 
  }
  
  
fpath.GNTRname <- function(config, i, r) {
  GNTRname <- paste(fpath.GNTname(config, i), fnc.replicate, r, sep="")
  GNTRname
  }


fpath.GNTdpath <- function(config, i) {
  GNTdpath <- paste(config$dpath, "/", config$a.f.p, fpath.GNTname(config, i), sep="")
  GNTdpath
  }
  
  
fpath.multree <- function(config, i) {
  multree.fpath <- paste(fpath.GNTdpath(config, i), "/", config$a.f.p, 
                   fnc.multree, fpath.GNTname(config, i), ".txt", sep="")
  multree.fpath
  }

fpath.multree.pdf <- function(config, i) {
  multree.fpath.pdf <- paste(fpath.GNTdpath(config, i), "/", config$a.f.p, 
                   fnc.multree, fpath.GNTname(config, i), ".pdf", sep="")
  multree.fpath.pdf
  }


       
       
fpath.gtrees.fpathbase <- function(config, i, r) {
  gtrees.fpathbase <- paste(fpath.GNTdpath(config, i), "/", config$a.f.p, 
        fnc.simgtree, fpath.GNTRname(config, i, r), "-", sep="")
  gtrees.fpathbase
  }
  
fpath.gtree <- function(config, i, r, g) {
  gtree.fpath <- paste(fpath.gtrees.fpathbase(config, i, r), g, ".txt", sep="")
  gtree.fpath
  }
  
fpath.gtree.pdf <- function(config, i, r, g) {
  gtree.fpath <- paste(fpath.gtrees.fpathbase(config, i, r), g, ".pdf", sep="")
  gtree.fpath
  }

  
fpath.seqs.fpathbase <- function(config, i, r) {
  seqs.fpathbase <- paste(fpath.GNTdpath(config, i), "/", config$a.f.p, 
        fnc.simseq, fpath.GNTRname(config, i, r), "-", sep="")
  seqs.fpathbase
  }
  
fpath.seq <- function(config, i, r, g) {
  seq.fpath <- paste(fpath.seqs.fpathbase(config, i, r), g, ".txt", sep="")
  seq.fpath
  } 


fpath.beastxml <- function(config, i, r) {
  beastxml <- paste(fpath.GNTdpath(config, i), "/", config$a.f.p, 
            fnc.beastxml, fpath.GNTRname(config, i, r), ".xml", sep="")
  beastxml
  }

fpath.sampledgtrees.fpathbase <- function(config, i, r) {
  sampledgtrees.fpathbase <- paste(fpath.GNTdpath(config, i), "/", config$a.f.p, 
           fnc.sampledgtrees, fpath.GNTRname(config, i, r), "-", sep="")
  sampledgtrees.fpathbase
  }
  
fpath.sampledgtree <- function(config, i, r, g) {
  sampledgtree.fpath <- paste(fpath.sampledgtrees.fpathbase(config, i, r), g, ".txt", sep="")
  sampledgtree.fpath
  }  
  
fpath.sampledmultrees <- function(config, i, r) {
  sampledmultrees.fpath <- paste(fpath.GNTdpath(config, i), "/", config$a.f.p, 
            fnc.sampledmultrees, fpath.GNTRname(config, i, r), ".txt", sep="")
  sampledmultrees.fpath
  }
  
fpath.sampledparams <- function(config, i, r) {  
  sampledparams.fpath <- paste(fpath.GNTdpath(config, i), "/", config$a.f.p,
                 fnc.sampledparams, fpath.GNTRname(config, i, r), ".txt", sep="")
  sampledparams.fpath
  }

fpath.DBUGTUNE <- function(config, i, r) {
  DBUGTUNE.fpath <- paste(fpath.GNTdpath(config, i), "/", config$a.f.p, 
                   fnc.DBUGTUNE, fpath.GNTRname(config, i, r), ".txt", sep="")
  DBUGTUNE.fpath
  }
  

fpath.mccgtrees.fpathbase <- function(config, i, r) {
  mccgtrees.fpathbase <- paste(fpath.GNTdpath(config, i), "/", config$a.f.p, 
           fnc.concensusgtree, fpath.GNTRname(config, i, r), "-", sep="")
  mccgtrees.fpathbase
  }
  
  
fpath.mccgtree <- function(config, i, r, g) {
  mccgtree.fpath <- paste(fpath.mccgtrees.fpathbase(config, i, r), g, ".txt", sep="")
  mccgtree.fpath
  }
  
fpath.mccgtree.pdf <- function(config, i, r, g) {
  mccgtree.fpath <- paste(fpath.mccgtrees.fpathbase(config, i, r), g, ".pdf", sep="")
  mccgtree.fpath
  }  

fpath.mccmultree <- function(config, i, r) {
  mccmultree.fpath <- paste(fpath.GNTdpath(config, i), "/", config$a.f.p, 
           fnc.concensusmultree, fpath.GNTRname(config, i, r), ".txt", sep="")
  mccmultree.fpath
  }
  
fpath.mccmultree.pdf <- function(config, i, r) {
  mccmultree.fpath <- paste(fpath.GNTdpath(config, i), "/", config$a.f.p, 
           fnc.concensusmultree, fpath.GNTRname(config, i, r), ".pdf", sep="")
  mccmultree.fpath
  }

#################################################################################


parse.progparams <- function(progparam.lines) {
  tokens <- strsplit(progparam.lines, split="[[:blank:]]+")
  
  linenum <- 1
  stopifnot(tokens[[linenum]][1] == "beastseed")
  stopifnot(length(tokens[[linenum]]) == 2)
  beastseed <- as.integer(tokens[[linenum]][2])

  linenum <- 2
  stopifnot(tokens[[linenum]][1] == "beastchainlength")
  stopifnot(length(tokens[[linenum]]) == 2)
  beastchainlength <- as.integer(tokens[[linenum]][2])

  linenum <- 3
  stopifnot(tokens[[linenum]][1] == "beastscreen.logevery")
  stopifnot(length(tokens[[linenum]]) == 2)
  beastscreen.logevery <- as.integer(tokens[[linenum]][2])

  linenum <- 4
  stopifnot(tokens[[linenum]][1] == "beastparams.logevery")
  stopifnot(length(tokens[[linenum]]) == 2)
  beastparams.logevery <- as.integer(tokens[[linenum]][2])

  linenum <- 5
  stopifnot(tokens[[linenum]][1] == "beastgtrees.logevery")
  stopifnot(length(tokens[[linenum]]) == 2)
  beastgtrees.logevery  <- as.integer(tokens[[linenum]][2])

  linenum <- 6
  stopifnot(tokens[[linenum]][1] == "beastmultree.logevery")
  stopifnot(length(tokens[[linenum]]) == 2)
  beastmultree.logevery <- as.integer(tokens[[linenum]][2])

  linenum <- 7
  stopifnot(tokens[[linenum]][1] == "beastdbugtune.logevery")
  stopifnot(length(tokens[[linenum]]) == 2)
  beastdbugtune.logevery  <- as.integer(tokens[[linenum]][2])

  linenum <- 8
  stopifnot(tokens[[linenum]][1] == "treeannburnin")
  stopifnot(length(tokens[[linenum]]) == 2)
  treeannburnin <- as.integer(tokens[[linenum]][2])
  
  list(beastseed=beastseed, beastchainlength=beastchainlength,
       beastscreen.logevery=beastscreen.logevery, beastparams.logevery=beastparams.logevery,
       beastgtrees.logevery=beastgtrees.logevery, beastmultree.logevery=beastmultree.logevery,
       beastdbugtune.logevery=beastdbugtune.logevery, treeannburnin=treeannburnin)
 }



read.config <- function(config.dir) {
  filepath <- paste(config.dir, "/", "config.txt", sep="")
  a.f.p <- all.files.prefix.from.config.dir(config.dir)
  all.lines <- readLines(filepath)
  ppline <- which(grepl("PROGRAMPARAMETERS", all.lines))
  if (length(ppline) == 0) {
    progparams <- list(beastseed=42, beastchainlength=1500000,
           beastscreen.logevery=10000, beastparams.logevery=1000,
           beastgtrees.logevery=1000, beastmultree.logevery=1000,
           beastdbugtune.logevery=10000, treeannburnin=501)
    config.lines <- all.lines
    } else {
    stopifnot(length(ppline) == 1)
    scenline <- which(grepl("SCENARIO", all.lines)) 
    stopifnot(length(scenline) == 1)
    config.lines <- all.lines[ (scenline+1) : length(all.lines) ]
    progparam.lines <- all.lines[ (ppline+1) : (scenline-1) ]
    progparams <- parse.progparams(progparam.lines)
    }
  
  tokens <- strsplit(config.lines, split="[[:blank:]]+")
  
  linenum <- 1
  stopifnot(tokens[[linenum]][1] == "nofGNRT")
  stopifnot(length(tokens[[linenum]]) == 2)
  nofGNRT <- as.integer(tokens[[linenum]][2])
  
  nofconfigs <- 0
  for (i in 1:nofGNRT) {
    ntokens <- length(tokens[[linenum+i]])
    stopifnot(ntokens > 3)
    nofconfigs <- nofconfigs + ntokens - 3
    }
  
  configG <- rep(0, nofconfigs)
  configN <- rep(0, nofconfigs)
  configR <- rep(0, nofconfigs)
  configT <- rep(0, nofconfigs)
  cfg <- 1
  for (i in 1:nofGNRT) {
    G <- as.integer(tokens[[1+i]][1])
    N <- as.integer(tokens[[1+i]][2])
    R <- as.integer(tokens[[1+i]][3])
    nofTs <- length(tokens[[1+i]]) - 3
    for (j in 1:nofTs) {
      configG[cfg] <- G
      configN[cfg] <- N
      configR[cfg] <- R
      configT[cfg] <- as.double(tokens[[1+i]][3+j])
      cfg <- cfg + 1
      }
    }
  
  linenum <- nofGNRT + 2
  stopifnot(tokens[[linenum]][1] == "genelength")
  stopifnot(length(tokens[[linenum]]) == 2)
  genelength <- as.integer(tokens[[linenum]][2])
  
  
  linenum <- nofGNRT + 3
  stopifnot(tokens[[linenum]][1] == "nofdips")
  stopifnot(length(tokens[[linenum]]) == 2)
  nofdips <- as.integer(tokens[[linenum]][2])
  
  linenum <- nofGNRT + 4
  stopifnot(tokens[[linenum]][1] == "noftets")
  stopifnot(length(tokens[[linenum]]) == 2)
  noftets <- as.integer(tokens[[linenum]][2])

  nofmultreetips <- nofdips + 2*noftets
  if (genelength == 0) {
    stopifnot(identical(nofconfigs, 1))
    stopifnot(identical(configG[1], 1))
    stopifnot(identical(configN[1], 1))
    stopifnot(identical(configR[1], 1))
    mulnodes <- NULL
  } else {
    mulnodes <- read.multree.nodes(tokens, linenum, nofmultreetips)
    check.mulnodes(mulnodes, nofmultreetips, nofdips, noftets)
  }
  network <- list(nofdips=nofdips, noftets=noftets, mulnodes=mulnodes)                        
  seqs <- list(len=genelength)
  list(progparams=progparams, configG=configG, configN=configN, configT=configT, configR=configR, 
         seqs=seqs, network=network, dpath=config.dir, a.f.p=a.f.p)
  }
  

check.mulnodes <- function(mulnodes, nofmultreetips, nofdips, noftets) {
  stopifnot(2*nofmultreetips - 1 == length(mulnodes))
  countAs <- 0
  countBs <- 0
  for (i in 1:length(mulnodes)) {
    if (i <= nofmultreetips) {
      stopifnot(nchar(mulnodes[[i]]$clade) == 2)
      if (substr(mulnodes[[i]]$clade, 2, 2) == "A") {
        countAs <- countAs +1
        }
      if (substr(mulnodes[[i]]$clade, 2, 2) == "B") {
        countBs <- countBs +1
        } 
      } else {
      } 
    }
  stopifnot(countBs == noftets)
  stopifnot(countAs - countBs == nofdips)
  for (i in 1:length(mulnodes)) {
    for (j in 1:length(mulnodes)) {   
      if ((i < j)  &&  cladeispair(mulnodes[[i]]$clade, mulnodes[[j]]$clade)) {
        stopifnot(mulnodes[[i]]$hybheight == mulnodes[[j]]$hybheight)
        stopifnot(mulnodes[[i]]$nheight == mulnodes[[j]]$nheight)
        stopifnot(mulnodes[[i]]$tippop == mulnodes[[j]]$tippop)
        stopifnot(mulnodes[[i]]$rootpop == mulnodes[[j]]$rootpop)
        stopifnot(mulnodes[[i]]$hybpop == mulnodes[[j]]$hybpop)
        }
      }
    } 
  }


# for checks
cladeispair <- function(clade1, clade2) {
  if (nchar(clade1) != nchar(clade2)) {
    return (FALSE)
    }
  nc <- nchar(clade1)
  pair <- TRUE
  for (n in 1:nc) {
    c1 <- substr(clade1, n, n) 
    c2 <- substr(clade2, n, n)
    same <- ((c1 == c2) || (c1=="A"  && c2 == "B") || (c1=="B"  && c2 == "A"))
    if (!same) {
      pair <- FALSE
      }
    }
  pair
  }
  
  
read.multree.nodes <- function(tokens, startlinenum, nofmultreetips) {
  nofmulnodes <- 2*nofmultreetips - 1
  linenum  <- startlinenum
  nodes <- as.list(NULL)
  for (i in 1:nofmulnodes) {
    linenum <- startlinenum + i
    node <- read.mulnode(tokens, linenum, (i <= nofmultreetips), (i == nofmulnodes))
    nodes <- c(nodes, list(node))
    }
  nodes
  }
  

  
  
read.mulnode <- function(tokens, linenum, tip, root) {
  stopifnot(length(tokens[[linenum]]) == 11)
  nheight <- 0
  hybheight <- -1
  tippop <- -1
  rootpop <- -1
  hybpop <- -1  
  indivs <- -1  
  clade <- tokens[[linenum]][1]
  
  if (tip) {
    stopifnot(nchar(clade) == 2)
    } else {
    stopifnot(nchar(clade) >= 5)
    }
  
  stopifnot(tokens[[linenum]][2] == "hgt")
  nheight <- as.double(tokens[[linenum]][3])
  stopifnot(is.finite(nheight))
  if (tip) {
    stopifnot(nheight == 0)
    } else {
    stopifnot(nheight > 0)
    }
    
  stopifnot(tokens[[linenum]][4] == "hybhgt")
  if (tokens[[linenum]][5] != "*") {
    hybheight <- as.double(tokens[[linenum]][5])
    stopifnot(is.finite(hybheight))
    }
    
  stopifnot(tokens[[linenum]][6] == "tipp")
  if (tip) {
    tippop <- as.double(tokens[[linenum]][7])
    stopifnot(is.finite(tippop))
    }
  
  stopifnot(tokens[[linenum]][8] == "rootp")
  if (tokens[[linenum]][9] != "*") {
    rootpop <- as.double(tokens[[linenum]][9])
    stopifnot(is.finite(rootpop))
    } else {
    stopifnot(root)
    }
    
  stopifnot(tokens[[linenum]][10] == "hybp")
  if (tokens[[linenum]][11] != "*") {
    hybpop <- as.double(tokens[[linenum]][11])
    stopifnot(is.finite(hybpop))
    }
    
  list(clade=clade, nheight=nheight, hybheight=hybheight, 
       tippop=tippop, rootpop=rootpop, hybpop=hybpop,
       root=root, indivs=indivs)  
  } 



