# Started 2012-09-08
# I want code for converting TreeAnnotator code to PDF (Call TreeAnnotator? 
# Or do it in R?)
# Also code for examining sequences (eg distance matrix) for checking 
# simulated genes make sense.



# code below from Analysis_LookAtTrees.r



library(ape)




glue <- function(...) {
  paste(..., sep="")
}


remove.annotations <- function(charvect) {
string <- paste(charvect, sep="", collapse="")
noannotbitslist <- strsplit(string, "[[][^][]*[]]")
#print(noannotbitslist)
# [[] matches [
# [^][]* matches anything without ] or [
# []] matches ]
noannotbits <- paste(noannotbitslist[[1]], sep="", collapse="")
#cat("noannotbits\n")
#print(noannotbits)
noannotbits
}   



tree.from.nexus <- function(filepath) {
x <- scan(filepath, what="", sep="\n", quiet=TRUE)
begin.trees.index <- grep("BEGIN TREES;", x=x, ignore.case=TRUE)
all.trees <- x[(begin.trees.index +1):length(x)]
end.trees.index <-  grep("END;|ENDBLOCK;", x=all.trees, ignore.case=TRUE)
all.trees <- all.trees[1:(end.trees.index-1)]
first.tree.index <- grep("TREE", x=all.trees, ignore.case=TRUE)
first.tree <- all.trees[first.tree.index]
translate.block <- all.trees[1:(first.tree.index-1)] 
#print(translate.block)
ntips <- length(translate.block) - 2
stopifnot(grepl("TRANSLATE", translate.block[1], ignore.case=TRUE))
stopifnot(grepl(";", translate.block[ntips+2], ignore.case=TRUE))
translate.block <- translate.block[2:(ntips+1)]
tipnameslist  <-  strsplit(translate.block, "[ \t,]")
#print(tipnameslist)
tipnames <- rep("", ntips)
for (i in 1:ntips) {
  tipnames[i] <- tipnameslist[[i]][length(tipnameslist[[i]])]
  }
tree.charvect <- unlist(strsplit(first.tree, ""))
list(tree.charvect=tree.charvect, tipnames=tipnames)
}



fpath.to.newick <- function(fpath) {
tree.tips.txt <- tree.from.nexus(fpath)
tree.charvect <- tree.tips.txt$tree.charvect
op <- which(tree.charvect=="(")
sc <- which(tree.charvect==";")
stopifnot(length(sc)==1)
charvect <- tree.charvect[op[1]:sc]
tipnames <- tree.tips.txt$tipnames
#print(tipnames)
newick <- paste(charvect, sep="", collapse="")
newick <- remove.annotations(newick)
charvect <- unlist(strsplit(newick, ""))
oporcomma <- which((charvect == "(")  |  (charvect == ","))
colons <- which(charvect == ":")
#print(oporcomma)
#print(colons)
#print(charvect)
#print(paste(charvect, sep="", collapse=""))
for (i in 1:length(oporcomma)) {
  for (j in 1:length(colons)) {
    if (oporcomma[i]+2 == colons[j]  ||  oporcomma[i]+3 == colons[j]) {    # assume one or two digit tip index (1...99)
      k1 <- oporcomma[i] + 1
      k2 <- oporcomma[i] + 2
      digittext <- ""
      isdig1 <- grepl("[[:digit:]]", charvect[k1])[1]
      if (isdig1) {
        digittext <- charvect[k1]
        isdig2 <- grepl("[[:digit:]]", charvect[k2])[1]
        if (isdig2) {
          digittext <- paste(digittext, charvect[k2], sep="") 
          }
        idx <- as.integer(digittext)
        charvect[k1] <- tipnames[idx]
        if (isdig2) {
          charvect[k2] <- ""
          }       
        }
      }
    }
  }
newick <- paste(charvect, sep="", collapse="")
newick
}


plot.tree.from.nexus.file <- function(fpath, branchcolour="black") {
  newick <- fpath.to.newick(fpath)
  phylo.tree <- read.tree(text=newick)
  plot.phylo(phylo.tree, edge.color=branchcolour)
  axisPhylo()
  }
  













