#                             AlloppDT. 
# For no data for testing prior

# Started 2012-10-17
# This is for the network model with an arbitrary number
# of diploids (>=2), tetraploids (>=1) and hybridizations.




################################################################################
###################### Setting up file paths, loading code #####################

cat("AlloppDT started\n")
#Args <- commandArgs(TRUE)
Args <- c("VOSTROWIN7", "C:/Users/Graham/AAA/Programming/GoteborgSim/2012-10-17-nodata/Z")

stopifnot(length(Args) == 2)
computer <- Args[1]
stopifnot(Args[1] == "VOSTROWIN7" || Args[1] == "DELLVISTA" || 
          Args[1] == "NETBOOKWIN7" || Args[1] == "NETBOOKUBUNTU" ||
          Args[1] == "CLUSTER")
config.dir <- Args[2]
# input config is here. All output goes in subdirectories of this


# where this code is. todo: other machines
if (computer=="VOSTROWIN7") {
  setwd("C:/Users/Graham/AAA/Programming/Goteborg/AlloppRcode-nhybs")
  } else if  (computer=="DELLVISTA") {
  setwd("C:/AAA/Programming/Goteborg/AlloppRcode")
  } else if  (computer=="NETBOOKWIN7") {
  setwd("C:/AAA/Programming/Goteborg/simulation_di_tets_multigene")
  } else if  (computer=="NETBOOKUBUNTU") {
  setwd("/home/graham/simulation_di_tets_multigene")
  } else if  (computer=="CLUSTER") {
  setwd("/home/gjones/simulation_di_tets_multigene")
  }


# java classpath for calling BEAST. todo: other machines
if (computer=="VOSTROWIN7") {
  java.classpath <- "."
  java.classpath <- paste(java.classpath, "C:\\Users\\Graham\\AAA\\Programming\\Goteborg\\beasttrunk20120509\\out\\production\\Beasttrunk20120509" ,sep=";")
  java.classpath <- paste(java.classpath, "C:\\Users\\Graham\\AAA\\Programming\\Goteborg\\beasttrunk20120509\\lib\\*" ,sep=";")
  } else if  (computer=="DELLVISTA") {
  java.classpath <- ".;C:\\AAA\\Programming\\Goteborg\\workspace\\beast16\\bin;C:\\AAA\\Programming\\Goteborg\\workspace\\beast16\\lib\\*"
  } else if  (computer=="NETBOOKWIN7") {
  java.classpath <- ".;C:\\AAA\\Programming\\Goteborg\\workspace\\beast16\\bin;C:\\AAA\\Programming\\Goteborg\\workspace\\beast16\\lib\\*"
  } else if  (computer=="NETBOOKUBUNTU") {
  java.classpath <- "'.:/home/graham/Programming/workspace/beast16/bin/:/home/graham/Programming/workspace/beast16/lib/*'" 
  } else if  (computer=="CLUSTER") {
  java.classpath <- "'.:/home/gjones/beast16/build/:/home/gjones/beast16/lib/*'"
  }   

               
# for calling Seq-Gen             
if (computer=="VOSTROWIN7") {
  seqgenbasecmd <- "seqgen.exe -mHKY -t3.0 -f0.3,0.2,0.2,0.3"
  } else if  (computer=="DELLVISTA") {
  seqgenbasecmd <- "seqgen.exe -mHKY -t3.0 -f0.3,0.2,0.2,0.3"
  } else if  (computer=="NETBOOKWIN7") {
  seqgenbasecmd <- "seqgen.exe -mHKY -t3.0 -f0.3,0.2,0.2,0.3"
  } else if  (computer=="NETBOOKUBUNTU") {
  seqgenbasecmd <- "$PWD/seqgen -mHKY -t3.0 -f0.3,0.2,0.2,0.3" 
  } else if  (computer=="CLUSTER") {
  seqgenbasecmd <- "$PWD/seqgen -mHKY -t3.0 -f0.3,0.2,0.2,0.3"
  }
  

library(ape)

source("AlloppDT_0randomseeds.r")
source("AlloppDT_1readconfig.r")
source("AlloppDT_2makemultree.r")
source("AlloppDT_3makegtrees.r")
source("AlloppDT_4makeseqfiles.r")
source("AlloppDT_5beastxml_toplevel.r")
source("AlloppDT_6beastxml_bits.r")
source("AlloppDT_7utils.r")

################################################################################
######################### Top level functions ##################################



taxa.for.nodata <- function(config) {
  ndips <- config$network$nofdips
  ntets <- config$network$noftets
  stopifnot(ndips + ntets <= 26)
  spp <-  unlist(strsplit("abcdefghijklmnopqrstuvwxyz",""))
  num <- "01"
  taxa <- rep("", ndips + 2*ntets)
  for (i in 1:ndips) {
    taxa[i] <- glue(num, spp[i], "A")
  }
  for (j in 1:ntets) {
    sp <- 27 - j
    i <- ndips + 2*j - 1
    taxa[i] <- glue(num, spp[sp], "A")
    i <- ndips + 2*j
    taxa[i] <- glue(num, spp[sp], "B")
  }
  taxa
}
 




make.sequences.for.nodata <- function(config) { 
  taxa <- taxa.for.nodata(config)
  sink(fpath.seq(config, 1, 1, 1))
  cat(length(taxa), "1", "\n")
  for (tx in 1:length(taxa)) {
    cat(taxa[tx], "      ?\n")
    }
  sink(NULL)
}
  
  
  
  
  
  

make.beastxml.for.nodata <- function(config) {  
   make.sequences.for.nodata(config) 

  # Make BEAST XML
  i <- 1
  r <- 1
  sink(fpath.beastxml(config, i, r))
  make.beastxml.from.sim.network(config$network, config$configG[i],
                taxa.for.nodata(config),
                popmean.eventrate.relativerates.prior=c(-3,.1, 5,.1, 0,1),
                fpath.seqs.fpathbase(config, i, r), 
                fpath.sampledgtrees.fpathbase(config, i, r),
                fpath.sampledmultrees(config, i, r), 
                fpath.sampledparams(config, i, r), 
                fpath.DBUGTUNE(config, i, r))
  sink(NULL)
  }

 
  


    
    
    
  
################################################################################
########################## Business starts here ################################


cat("AlloppDT running with directory", config.dir, "\n")

config <- read.config(config.dir)


nofGNT <- length(config$configG)
beast.randomseed <- config$progparams$beastseed
beast.chain.length <- config$progparams$beastchainlength
beast.screen.logevery <- config$progparams$beastscreen.logevery
beast.params.logevery <- config$progparams$beastparams.logevery
beast.gtrees.logevery <- config$progparams$beastgtrees.logevery
beast.multree.logevery <- config$progparams$beastmultree.logevery
beast.dbugtune.logevery <- config$progparams$beastdbugtune.logevery
treeann.burnin <- config$progparams$treeannburnin


dir.create(fpath.GNTdpath(config, 1))

taxa <- taxa.for.nodata(config)
taxastruct <- taxa.array.to.structure(taxa)

make.sequences.for.nodata(config)
make.beastxml.for.nodata(config)



#for (i in 1:nofGNT) {
#  
#  
#  
#  # Make the MUL-tree
#  multree <- make.multree(config$network)
#  # add nlins at tips
#  for (nn in 1:length(multree)) {
#    if (multree[[nn]]$nheight == 0) {
#       multree[[nn]]$nlins <- config$configN[i]
#      }
#    }  
#  Newick.multree <- multree.to.Newick(multree)
#  print(Newick.multree)
#  phylo.multree <- read.tree(text=Newick.multree)
#  pdf(file=fpath.multree.pdf(config, i))
#  plot.phylo(phylo.multree)
#  axisPhylo()
#  #hgt <- max(branching.times(phylo.multree)) 
#  #text(c(0,hgt),c(1,2),c("0,1","hgt,2"))
#  #nodelabels(1:11, 1:11)
#  title("Simulated MUL-tree")
#  dev.off()
#
#  
#  sink(fpath.multree(config, i))
#  print.multree(multree)
#  sink(NULL)
#  
#  for (r in replicate.sets[[i]]) {
#    make.beastxml.for.one.GNT.one.replicate(config, i, r)
#    }
#  }
#
#
#
#for (i in 1:nofGNT) {
#  for (r in replicate.sets[[i]]) {
#    run.beast.for.one.GNT.one.replicate(config, i, r)
#    }
#  }





