
library(ape)
library(phangorn)

basefpath <- "C:/Users/Graham/AAA/Programming/GoteborgSim/2012-10-08/I/Ig3n1t20/I2SQg3n1t20r"

glue <- function(...) {
paste(..., sep="")
}

pdf(file=NULL, width=9, height=12)
layout(matrix(1:30,nrow=10,ncol=3,byrow=TRUE))
treelist <- NULL
tryplotlist <- NULL
for (r in 1:10) {
  for (g in 1:3) {
    fpath <- glue(basefpath, r, "-", g, ".txt")
    seqs <- read.dna(file=fpath, format="sequential")
    mat <- dist.dna(seqs, as.matrix=TRUE)
    tree <- upgma(mat)
    treelist <- c(treelist, list(tree))
    par(mar=c(1,1,1,1)+.1)
    tryplot <- plot.phylo(tree, cex=1.2, plot=FALSE)
    tryplotlist <- c(tryplotlist, list(tryplot))
    }
  }
dev.off()  
      
pdf(file=glue(basefpath, "-1-10-", "upgma-gtrees.pdf"), width=9, height=12)
layout(matrix(1:30,nrow=10,ncol=3,byrow=TRUE))
for (r in 1:10) {
  for (g in 1:3) {
    par(mar=c(1,1,1,1)+.1)
    tryplot <- tryplotlist[[g]]
    xextend <- (tryplot$x.lim[2] - tryplot$x.lim[1]) * .2
    x.lim <- c(tryplot$x.lim[1]-xextend, tryplot$x.lim[2]+xextend)
    yextend <- (tryplot$x.lim[2] - tryplot$x.lim[1]) * .1
    y.lim <- c(tryplot$y.lim[1]-yextend, tryplot$y.lim[2]+yextend)
  
    plot.phylo(treelist[[g]], cex=1, x.lim=x.lim, y.lim=y.lim)
    }
  }
dev.off()
    
  
  
  
  
  