

library(ape)

setwd("C:/Users/Graham/AAA/Programming/Goteborg/AlloppRcode-nhybs")

source("AlloppDT_1readconfig.r")



get.numhybs.ok <- function(config.dir, trueh) {
  cat(config.dir, "\n")
  config <- read.config(config.dir)
  #print(config)
  nGNTs <- length(config$configG)
  props <- matrix(0,nrow=nGNTs,ncol=config$configR[1])
  propsnames <- rep("", nGNTs)
  
  for (gnt in 1:nGNTs) {
    propsnames[gnt] <- paste("G=", config$configG[gnt], " N=", config$configN[gnt], " T=", config$configT[gnt], sep="")
    } 
  for (gnt in 1:nGNTs) {
    for (r in 1:config$configR[gnt]) {
      logfpath <- fpath.sampledparams(config, gnt, r)
      x <- read.table(file=logfpath, header=TRUE, skip=2)
      nh <- x[502:1501, "NumHybs"]
      #print(nh)
      numh <- length(nh)
      numtrue<- length(which(nh==trueh))
      #cat("G", config$configG[gnt], "N", config$configN[gnt], "T", config$configT[gnt], "P(1)", numtrue/numh, "\n")
      props[gnt,r] <- numtrue/numh
      }
    }
  rownames(props) <- propsnames
  props
  } 


props.D <- get.numhybs.ok("C:/Users/Graham/AAA/Programming/GoteborgSim/2012-11-05/D", 1)
props.E <- get.numhybs.ok("C:/Users/Graham/AAA/Programming/GoteborgSim/2012-11-05/E", 2)
props.F <- get.numhybs.ok("C:/Users/Graham/AAA/Programming/GoteborgSim/2012-11-05/F", 3)

nGNTs <- nrow(props.D)
ncols <- nGNTs/2

plotgraphs <- function() {
  par(mfrow=c(ncols,3*2), mar=c(2,2,3,1)+.1)
  for (gnt in 1:nGNTs) {
    plot(props.D[gnt,], ann=FALSE, ylim=c(0,1), pch=16)
    title(main=paste("D", rownames(props.D)[gnt]))
    
    plot(props.E[gnt,], ann=FALSE, ylim=c(0,1), pch=16)
    title(main=paste("E", rownames(props.E)[gnt]))
    
    plot(props.F[gnt,], ann=FALSE, ylim=c(0,1), pch=16)
    title(main=paste("F", rownames(props.F)[gnt]))
  }
}

plotgraphs()

svg(filename="C:/Users/Graham/AAA/Programming/Goteborg/AlloppRcode-nhybs/2012-11-05-DEF.svg", pointsize=10)
plotgraphs()
dev.off()

pdf(file="C:/Users/Graham/AAA/Programming/Goteborg/AlloppRcode-nhybs/2012-11-05-DEF.pdf", pointsize=9)
plotgraphs()
dev.off()




#
#get.numhybs.props <- function(config.dir) {
#  cat(config.dir, "\n")
#  config <- read.config(config.dir)
#  print(config)
#  nGNTs <- length(config$configG)
#  props <- matrix(0,nrow=nGNTs,ncol=config$configR[1])
#  for (gnt in 1:nGNTs) {
#    for (r in 1:config$configR[gnt]) {
#      logfpath <- fpath.sampledparams(config, gnt, r)
#      x <- read.table(file=logfpath, header=TRUE, skip=2)
#      nh <- x[502:2501, "NumHybs"]
#      numh <- length(nh)
#      numh1 <- length(which(nh==1))
#      cat("G", config$configG[gnt], "N", config$configN[gnt], "T", config$configT[gnt], "P(1)", numh1/numh, "\n")
#      props[gnt,r] <- numh1/numh
#      }
#    }
#  props
#  } 
#props.H <- get.numhybs.props("C:/Users/Graham/AAA/Programming/GoteborgSim/2012-10-08/H")
#props.I <- get.numhybs.props("C:/Users/Graham/AAA/Programming/GoteborgSim/2012-10-08/I")
#
#par(mfrow=c(2,3))
#plot(2-props.H[1,],ylim=c(1,2), ylab="num hybs", xlab="replicate")
#title(main="scenario H, T=4e-8")
#plot(2-props.H[2,],ylim=c(1,2), ylab="num hybs", xlab="replicate")
#title(main="scenario H, T=2e-8")
#plot(2-props.H[3,],ylim=c(1,2), ylab="num hybs", xlab="replicate")
#title(main="scenario H, T=1e-8")
#plot(2-props.I[1,],ylim=c(1,2), ylab="num hybs", xlab="replicate")
#title(main="scenario I, T=4e-8")
#plot(2-props.I[2,],ylim=c(1,2), ylab="num hybs", xlab="replicate")
#title(main="scenario I, T=2e-8")
#plot(2-props.I[3,],ylim=c(1,2), ylab="num hybs", xlab="replicate")
#title(main="scenario I, T=1e-8")
#
#
#
#

