



plot.diagram <- function(w, h)
{
par(mar=c(0,0,0,0))
plot(NULL, xlim=c(0,w), ylim=c(0,h), axes=FALSE, ylab="", xlab="")
}



plot.rectangle <- function(v1,v2,...)
{
polygon(c(v1[1],v1[1],v2[1],v2[1]), c(v1[2],v2[2],v2[2],v1[2]), ...)
}

wid <- 28
hgt <- 38
brdx <- 4
brdy <- 6
plot.diagram(w=3*wid+brdx, h=3*hgt+brdy)



mock.rfd <- function(scen, G, N, TT) {
if (identical(scen,"D")) {
  Gx <- 0.6
  Nx <- 0.2
  Tx <- 0.4 
  } else if (identical(scen,"E")) {
  Gx <- 0.65
  Nx <- 0.25
  Tx <- 0.35 
  } else if (identical(scen,"F")) {
  Gx <- 0.55
  Nx <- 0.3
  Tx <- 0.35 
  } else {
  }
rfd <- 0.13
rfd <- rfd / ((G^Gx) * (N^Nx) * (TT^Tx))
rfd =  rfd * rlnorm(1,meanlog=0, sdlog=0.15)
rfd
}




for (g in 1:3) {
  G <- c(1,3,9)[g]
  GNox <- (g-1)*wid+brdx
  text(GNox+12, 2, paste("G=", G, sep=""), adj=c(0,0))
  for (n in 1:3) {
    N <- c(1,3,9)[n]
    GNoy <- (3-n)*hgt+brdy
    text(2, GNoy+14, paste("N=", N, sep=""), adj=c(0,0), srt=90)
    GNDoy <- GNoy + 26
    for (t in 1:5) {
      TT <- c(5,10,20,40,80)[t]
      
      plot.rectangle(c(GNox, GNDoy+(5-t)*2), c(GNox+250*mock.rfd("D",G,N,TT), GNDoy+(6-t)*2), border=NA, col="gray")
    }
    text(GNox+2, GNDoy+6, paste("D"), adj=c(0,0.5))
    
    GNEoy <- GNoy + 14
    for (t in 1:5) {
      TT <- c(5,10,20,40,80)[t]
      plot.rectangle(c(GNox, GNEoy+(5-t)*2), c(GNox+250*mock.rfd("E",G,N,TT), GNEoy+(6-t)*2), border=NA, col="gray")
    }
    text(GNox+2, GNEoy+6, paste("E"), adj=c(0,0.5))
    
    GNFoy <- GNoy + 2
    for (t in 1:5) {
      TT <- c(5,10,20,40,80)[t]
      plot.rectangle(c(GNox, GNFoy+(5-t)*2), c(GNox+250*mock.rfd("F",G,N,TT), GNFoy+(6-t)*2), border=NA, col="gray")
    }
    text(GNox+2, GNFoy+6, paste("F"), adj=c(0,0.5))
    plot.rectangle(c(GNox,GNoy), c(GNox+wid,GNoy+hgt))
  }
}










